
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.UI.Extensions";

import "PaulinoPlugins.PetCarousel";

edgePadding = 50;

function LoadSettings()

settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "PetCarouselSettings" );

	if ( type( settings ) ~= "table" ) then
		settings = { };
	end
	
	if ( not settings.welcome ) then
		settings.welcome = false;
	end

	if ( not settings.positionX ) then		
		settings.positionX = ( Turbine.UI.Display.GetWidth() - mainWindow:GetWidth() - edgePadding);		
	end
	
	if ( not settings.positionY ) then	
		settings.positionY = ( Turbine.UI.Display.GetHeight() - mainWindow:GetHeight() - edgePadding * 1.5 );
	end
	
	if ( not settings.alwayshide ) then
		settings.alwayshide = false;
	end
	
	if ( not settings.cosmeticpet ) then
		settings.cosmeticpet = false;
	end
	
	if ( not settings.qs1 ) then
		settings.qs1 = 0;
	end
	
	if ( not settings.qs2 ) then
		settings.qs2 = 1;
	end
	
	if ( not settings.qs3 ) then
		settings.qs3 = 2;
	end

	if ( not settings.cqs1 ) then
		settings.cqs1 = 0;
	end
	
	if ( not settings.cqs2 ) then
		settings.cqs2 = 1;
	end
	
	if ( not settings.cqs3 ) then
		settings.cqs3 = 2;
	end

end

function SaveSettings()

Turbine.PluginData.Save( Turbine.DataScope.Character, "PetCarouselSettings", settings );

end

--mainWindow = Turbine.UI.Lotro.Window();
mainWindow = Turbine.UI.Extensions.Window();
mainWindow:SetSize( 200 , 35 );
mainWindow:SetText("Pet Carousel");
mainWindow:SetOpacity( 0 );
mainWindow:SetFadeSpeed( 0.5 );
mainWindow:SetVisible( true );

LoadSettings();

mainWindow:SetPosition(settings.positionX, settings.positionY);

--local displayWidth, displayHeight = Turbine.UI.Display.GetSize();
--local windowWidth,windowHeight = mainWindow:GetSize();

--mainWindow:SetPosition((displayWidth-windowWidth)/2,(displayHeight - windowHeight)/2);

leftWindow = Turbine.UI.Extensions.SimpleWindow();
leftWindow:SetSize( 35 , 35 );
leftWindow:SetParent( mainWindow );
leftWindow:SetPosition( 47.5, 50 );
leftWindow:SetOpacity( 0.25 );
leftWindow:SetFadeSpeed( 0.5 );

centerWindow = Turbine.UI.Extensions.SimpleWindow();
centerWindow:SetSize( 35 , 35 );
centerWindow:SetParent( mainWindow );
centerWindow:SetPosition( 82.5, 40 );

rightWindow = Turbine.UI.Extensions.SimpleWindow();
rightWindow:SetSize( 35 , 35 );
rightWindow:SetParent( mainWindow );
rightWindow:SetPosition( 117.5, 50 );
rightWindow:SetOpacity( 0.25 );
rightWindow:SetFadeSpeed( 0.5 );

releaseWindow = Turbine.UI.Extensions.SimpleWindow();
releaseWindow:SetSize( 24, 10 );
releaseWindow:SetParent( mainWindow );
releaseWindow:SetPosition( 89, 79 );
releaseWindow:SetOpacity( 0.25 );
releaseWindow:SetFadeSpeed( 0.5 );

releaseButton = Turbine.UI.Button()
releaseButton:SetParent( releaseWindow );
releaseButton:SetText("X");
--releaseButton:SetBackground( "PaulinoPlugins/PetCarousel/Resources/x.png" );
releaseButton:SetSize( 24, 10 );
releaseButton:SetFontStyle( Turbine.UI.FontStyle.Outline );
releaseButton:SetForeColor( Turbine.UI.Color( 1, 0, 0 ) );
--releaseButton:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 1 ) );

petdata = { };

petdata[0] = "0x70003EB5"; -- Raven
petdata[1] = "0x70003EB8"; -- Bear
petdata[2] = "0x7000B8D3"; -- Lynx
petdata[3] = "0x70000FB2"; -- Eagle
petdata[4] = "0x7000F530"; -- Saber Tooth
petdata[5] = "0x7000F54D"; -- Bog Guardian

petqs = { };

for i = 0, 5 do

	petqs[i] = Turbine.UI.Lotro.Quickslot();
	petqs[i]:SetShortcut( Turbine.UI.Lotro.Shortcut( 6.0, petdata[i] ) );

end

cosmeticpetdata = { };

cosmeticpetdata[0] = "0x7000BF8E"; -- Turtle
cosmeticpetdata[1] = "0x7000BF72"; -- Bird
cosmeticpetdata[2] = "0x7000BF73"; -- Cat
cosmeticpetdata[3] = "0x7000BF74"; -- Dog
cosmeticpetdata[4] = "0x7000BF75"; -- Fox
cosmeticpetdata[5] = "0x7000BF76"; -- Frog
cosmeticpetdata[6] = "0x7000BF77"; -- Rabbit
cosmeticpetdata[7] = "0x7000BF78"; -- Snake
cosmeticpetdata[8] = "0x7000BF79"; -- Squirrel

cosmeticpetqs = { };

for i = 0, 8 do

	cosmeticpetqs[i] = Turbine.UI.Lotro.Quickslot();
	cosmeticpetqs[i]:SetShortcut( Turbine.UI.Lotro.Shortcut( 6.0, cosmeticpetdata[i] ) );

end

leftqs = Turbine.UI.Lotro.Quickslot();
leftqs:SetParent( leftWindow );
leftqs:SetPosition( 0, 0 );
leftqs:SetSize( 35, 35 );
leftqs:SetAllowDrop(false);

centerqs = Turbine.UI.Lotro.Quickslot();
centerqs:SetParent( centerWindow );
centerqs:SetPosition( 0, 0 );
centerqs:SetSize( 35, 35 );
centerqs:SetAllowDrop(false);

rightqs = Turbine.UI.Lotro.Quickslot();
rightqs:SetParent( rightWindow );
rightqs:SetPosition( 0, 0 );
rightqs:SetSize( 35, 35 );
rightqs:SetAllowDrop(false);

qs1 = settings.qs1;
qs2 = settings.qs2;
qs3 = settings.qs3;
cqs1 = settings.cqs1;
cqs2 = settings.cqs2;
cqs3 = settings.cqs3;

cosmeticpet = settings.cosmeticpet;

if (cosmeticpet == false) then

	leftqs:SetShortcut(petqs[qs1]:GetShortcut());
	centerqs:SetShortcut(petqs[qs2]:GetShortcut());
	rightqs:SetShortcut(petqs[qs3]:GetShortcut());

else

	leftqs:SetShortcut(cosmeticpetqs[cqs1]:GetShortcut());
	centerqs:SetShortcut(cosmeticpetqs[cqs2]:GetShortcut());
	rightqs:SetShortcut(cosmeticpetqs[cqs3]:GetShortcut());

end

if ( settings.welcome == false ) then
	Turbine.Shell.WriteLine(" *** Welcome to the Pet Carousel! ***\n - To show the help type /pc help");
end

PetCarouselCommand = Turbine.ShellCommand();

function PetCarouselCommand:Execute( command, arguments )

	if ( arguments == "help" ) then
		Turbine.Shell.WriteLine(" *** Pet Carousel Help ***\n\n - Use the Mouse Wheel over the middle Shortcut to move the Carousel\n - Right click the middle Shortcut to change to the Cosmetic Pet Carousel\n - Click the red cross to release your pet\n - Right click anywhere in the window to hide it. \n -Use the command '/pc' or '/petcarousel' to hide or show the Plugin.\n - Use the command '/pc restore' to move the window to its default position.\n - Use the command '/pc welcomeoff' to turn off the welcome message.\n - Use the command '/pc welcomeon' to turn on the welcome message.");
	elseif ( arguments == "welcomeoff" ) then
		settings.welcome = true;
		SaveSettings();
		Turbine.Shell.WriteLine("Welcome message has been disabled");
	elseif (arguments == "welcomeon" ) then
		settings.welcome = false;
		SaveSettings();
		Turbine.Shell.WriteLine("Welcome message has been enabled");
	elseif ( arguments == "restore" ) then
		settings.positionX = ( Turbine.UI.Display.GetWidth() - mainWindow:GetWidth() - edgePadding);		
		settings.positionY = ( Turbine.UI.Display.GetHeight() - mainWindow:GetHeight() - edgePadding * 1.5 );
		mainWindow:SetPosition(settings.positionX, settings.positionY);
		SaveSettings();
		Turbine.Shell.WriteLine("Window restored to its default position");
	elseif ( arguments ~= nil ) then
		mainWindow:SetVisible( not mainWindow:IsVisible() );
	end

end

Turbine.Shell.AddCommand( "pc;petcarousel", PetCarouselCommand );

mainWindow.MouseEnter = function( sender, args )

if (alwayshide == false) then
	mainWindow:SetOpacity( 0.75 );
end

rightWindow:SetOpacity( 0.75 );
leftWindow:SetOpacity( 0.75 );
releaseWindow:SetOpacity( 0.75 );

end

mainWindow.MouseLeave = function( sender, args )

X, Y = mainWindow:GetPosition();

if (alwayshide == false) then
	mainWindow:SetOpacity( 0 );
end

rightWindow:SetOpacity( 0.25 );
leftWindow:SetOpacity( 0.25 );
releaseWindow:SetOpacity( 0.25 );

if ( X ~= settings.positionX or Y ~= settings.positionY ) then
		
	settings.positionX = X;
	settings.positionY = Y;
	SaveSettings();
		
end

end

releaseButton.MouseUp = function( sender, args)

releaseButton:SetOutlineColor( Turbine.UI.Color( 1, 1, 1 ) );

end

releaseButton.MouseDown = function( sender, args)

releaseButton:SetOutlineColor( Turbine.UI.Color( 0, 0, 0 ) );

end


releaseButton.MouseEnter = function( sender, args)

releaseButton:SetOutlineColor( Turbine.UI.Color( 1, 1, 1 ) );

end

releaseButton.MouseLeave = function( sender, args)

releaseButton:SetOutlineColor( Turbine.UI.Color( 0, 0, 0 ) );

end

releaseButton.MouseClick = function( sender, args)

Turbine.Shell.Execute( "/pet releaseall" );
Turbine.Shell.WriteLine( "Pet released" );

end

alwayshide = settings.alwayshide;

mainWindow.MouseClick = function (sender, args)

if ( args.Button == Turbine.UI.MouseButton.Right ) then

	if (alwayshide == false ) then
		mainWindow:SetOpacity ( 0 );
		alwayshide = true;
	else
		mainWindow:SetOpacity( 0.75 );
		alwayshide = false;
	end
	
	settings.alwayshide = alwayshide;
	SaveSettings();

end

end

centerqs.MouseClick = function (sender, args)

if ( args.Button == Turbine.UI.MouseButton.Right ) then

	if (cosmeticpet == false) then

		leftqs:SetShortcut(cosmeticpetqs[cqs1]:GetShortcut());
		centerqs:SetShortcut(cosmeticpetqs[cqs2]:GetShortcut());
		rightqs:SetShortcut(cosmeticpetqs[cqs3]:GetShortcut());
		cosmeticpet = true;

	else

		leftqs:SetShortcut(petqs[qs1]:GetShortcut());
		centerqs:SetShortcut(petqs[qs2]:GetShortcut());
		rightqs:SetShortcut(petqs[qs3]:GetShortcut());
		cosmeticpet = false;

	end
	
	settings.cosmeticpet = cosmeticpet;
	SaveSettings();

end

end

centerqs.MouseWheel = function( sender, args )

	Carousel();

end

centerqs.MouseLeave = function( sender, args)

if ( settings.qs1 ~= qs1 or settings.cqs1 ~= cqs1 ) then

	settings.qs1 = qs1;
	settings.qs2 = qs2;
	settings.qs3 = qs3;

	settings.cqs1 = cqs1;
	settings.cqs2 = cqs2;
	settings.cqs3 = cqs3;

	SaveSettings();
	
end

end

function Carousel()

if (cosmeticpet == false) then

	qs1 = qs1 + 1;
	qs2 = qs2 + 1;
	qs3 = qs3 + 1;

	if (qs1 == 6) then
		qs1 = 0;
	elseif (qs2 == 6) then
		qs2 = 0;
	elseif (qs3 == 6) then
		qs3 = 0;
	end

	leftqs:SetShortcut(petqs[qs1]:GetShortcut());
	centerqs:SetShortcut(petqs[qs2]:GetShortcut());
	rightqs:SetShortcut(petqs[qs3]:GetShortcut());

else

	cqs1 = cqs1 +1;
	cqs2 = cqs2 +1;
	cqs3 = cqs3 +1;

	if (cqs1 == 9) then
		cqs1 = 0;
	elseif (cqs2 == 9) then
		cqs2 = 0;
	elseif (cqs3 == 9) then
		cqs3 = 0;
	end

	leftqs:SetShortcut(cosmeticpetqs[cqs1]:GetShortcut());
	centerqs:SetShortcut(cosmeticpetqs[cqs2]:GetShortcut());
	rightqs:SetShortcut(cosmeticpetqs[cqs3]:GetShortcut());

end

end